/*-
 * Copyright (C) 2010-2012, Centre National de la Recherche Scientifique,
 *                          Institut Polytechnique de Bordeaux,
 *                          Universite Bordeaux 1.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef X86_32_TRANSLATION_FUNCTIONS_HH
# define X86_32_TRANSLATION_FUNCTIONS_HH

# include "x86_32_translate.hh"

// X86_32_TRANSLATE_0_OP(CS);

// X86_32_TRANSLATE_PREFIX(CS);

// X86_32_TRANSLATE_0_OP(FS);

// X86_32_TRANSLATE_PREFIX(FS);

// X86_32_TRANSLATE_0_OP(SS);

// X86_32_TRANSLATE_PREFIX(SS);

// X86_32_TRANSLATE_0_OP(DS);

// X86_32_TRANSLATE_PREFIX(DS);

// X86_32_TRANSLATE_0_OP(ES);

// X86_32_TRANSLATE_PREFIX(ES);

// X86_32_TRANSLATE_0_OP(GS);

// X86_32_TRANSLATE_PREFIX(GS);

X86_32_TRANSLATE_0_OP(DATA16);   // x86_32_instr_prefixes.cc
X86_32_TRANSLATE_PREFIX(DATA32); // x86_32_instr_prefixes.cc
X86_32_TRANSLATE_PREFIX(DATA16); // x86_32_instr_prefixes.cc

X86_32_TRANSLATE_PREFIX(ADDR16); // x86_32_instr_prefixes.cc
X86_32_TRANSLATE_PREFIX(ADDR32); // x86_32_instr_prefixes.cc

X86_32_TRANSLATE_0_OP(AAA); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_0_OP(AAD); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(AAD); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_0_OP(AAM); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(AAM); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_0_OP(AAS); // x86_32_instr_arithmetics.cc


X86_32_TRANSLATE_2_OP(ADC); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(ADCB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(ADCW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(ADCL); // x86_32_instr_arithmetics.cc

X86_32_TRANSLATE_2_OP(ADD); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(ADDB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(ADDW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(ADDL); // x86_32_instr_arithmetics.cc


X86_32_TRANSLATE_2_OP(AND); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(ANDB); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(ANDW); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(ANDL); // x86_32_instr_booleans.cc

X86_32_TRANSLATE_2_OP(BOUND); // x86_32_instr_misc.cc
X86_32_TRANSLATE_2_OP(BOUND); // x86_32_instr_misc.cc

X86_32_TRANSLATE_2_OP(BSF); // x86_32_instr_bits.cc
X86_32_TRANSLATE_2_OP(BSR); // x86_32_instr_bits.cc

X86_32_TRANSLATE_1_OP(BSWAP); // x86_32_instr_misc.cc

X86_32_TRANSLATE_2_OP(BT);  // x86_32_instr_bits.cc
X86_32_TRANSLATE_2_OP(BTC); // x86_32_instr_bits.cc
X86_32_TRANSLATE_2_OP(BTR); // x86_32_instr_bits.cc
X86_32_TRANSLATE_2_OP(BTS); // x86_32_instr_bits.cc

X86_32_TRANSLATE_2_OP(BTW);  // x86_32_instr_bits.cc
X86_32_TRANSLATE_2_OP(BTCW); // x86_32_instr_bits.cc
X86_32_TRANSLATE_2_OP(BTRW); // x86_32_instr_bits.cc
X86_32_TRANSLATE_2_OP(BTSW); // x86_32_instr_bits.cc

X86_32_TRANSLATE_2_OP(BTL);  // x86_32_instr_bits.cc
X86_32_TRANSLATE_2_OP(BTCL); // x86_32_instr_bits.cc
X86_32_TRANSLATE_2_OP(BTRL); // x86_32_instr_bits.cc
X86_32_TRANSLATE_2_OP(BTSL); // x86_32_instr_bits.cc

X86_32_TRANSLATE_1_OP(CALL); // x86_32_operators_proc_call.cc

X86_32_TRANSLATE_0_OP(CBW); // x86_misc_instructions.cc
X86_32_TRANSLATE_0_OP(CBTW); // x86_misc_instructions.cc

X86_32_TRANSLATE_0_OP(CWDE); // x86_misc_instructions.cc
X86_32_TRANSLATE_0_OP(CWTL); // x86_misc_instructions.cc

X86_32_TRANSLATE_0_OP(CLC); // x86_32_instr_misc.cc

X86_32_TRANSLATE_0_OP(CLD); // x86_32_instr_misc.cc

X86_32_TRANSLATE_1_OP(CLFLUSH); // NOP / x86_32_instr_misc.cc

X86_32_TRANSLATE_0_OP(CLI);  // NOP / x86_32_instr_misc.cc

X86_32_TRANSLATE_0_OP(CLTS);  // NOP / x86_32_instr_misc.cc

X86_32_TRANSLATE_0_OP(CMC); // x86_32_instr_misc.cc

#define X86_32_CC(id, form) X86_32_TRANSLATE_2_OP(CMOV ## id);
// x86_32_instr_mov.cc
#include "x86_32_cc.def"
#undef  X86_32_CC

X86_32_TRANSLATE_2_OP(CMOVC); // x86_32_instr_mov.cc
X86_32_TRANSLATE_2_OP(CMOVNC); // x86_32_instr_mov.cc

X86_32_TRANSLATE_2_OP(CMP); // x86_32_instr_misc.cc 
X86_32_TRANSLATE_2_OP(CMPB); // x86_32_instr_misc.cc 
X86_32_TRANSLATE_2_OP(CMPL); // x86_32_instr_misc.cc 
X86_32_TRANSLATE_2_OP(CMPW); // x86_32_instr_misc.cc 

X86_32_TRANSLATE_0_OP(CMPSB);  // x86_32_instr_strings.cc 
X86_32_TRANSLATE_2_OP(CMPSB);  // x86_32_instr_strings.cc 
X86_32_TRANSLATE_0_OP(CMPSW);  // x86_32_instr_strings.cc 
X86_32_TRANSLATE_2_OP(CMPSW);  // x86_32_instr_strings.cc 
X86_32_TRANSLATE_0_OP(CMPSD);  // x86_32_instr_strings.cc 
X86_32_TRANSLATE_2_OP(CMPSD);  // x86_32_instr_strings.cc 

X86_32_TRANSLATE_2_OP(CMPXCHG); // x86_32_instr_misc.cc 

X86_32_TRANSLATE_0_OP(CPUID); // NOP / x86_32_instr_misc.cc

// X86_32_TRANSLATE_2_OP(CRC32); 

X86_32_TRANSLATE_0_OP(CWD); // x86_32_instr_misc.cc
X86_32_TRANSLATE_0_OP(CDQ); // x86_32_instr_misc.cc


X86_32_TRANSLATE_0_OP(DAA); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_0_OP(DAS); // x86_32_instr_arithmetics.cc

X86_32_TRANSLATE_1_OP(DEC); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(DECB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(DECW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(DECL); // x86_32_instr_arithmetics.cc

X86_32_TRANSLATE_1_OP(DIV);  // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(DIVB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(DIVL); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(DIVW); // x86_32_instr_arithmetics.cc

X86_32_TRANSLATE_2_OP(ENTER); // x86_32_instr_stack.cc
X86_32_TRANSLATE_2_OP(ENTERW); // x86_32_instr_stack.cc
X86_32_TRANSLATE_2_OP(ENTERL); // x86_32_instr_stack.cc

X86_32_TRANSLATE_0_OP(HLT); // SINK / x86_32_instr_misc.cc

X86_32_TRANSLATE_1_OP(IDIV); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(IDIVB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(IDIVW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(IDIVL); // x86_32_instr_arithmetics.cc

X86_32_TRANSLATE_1_OP(IMUL); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(IMUL); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_3_OP(IMUL); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(IMULB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(IMULB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_3_OP(IMULB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(IMULW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(IMULW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_3_OP(IMULW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(IMULL); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(IMULL); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_3_OP(IMULL); // x86_32_instr_arithmetics.cc

// X86_32_TRANSLATE_2_OP(IN);

X86_32_TRANSLATE_1_OP(INC); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(INCB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(INCW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(INCL); // x86_32_instr_arithmetics.cc

// X86_32_TRANSLATE_0_OP(INSB);
// X86_32_TRANSLATE_2_OP(INSB);
// X86_32_TRANSLATE_0_OP(INSW);
// X86_32_TRANSLATE_2_OP(INSW);
// X86_32_TRANSLATE_0_OP(INSL);
// X86_32_TRANSLATE_2_OP(INSL);
// X86_32_TRANSLATE_0_OP(INSD);
// X86_32_TRANSLATE_2_OP(INSD);

X86_32_TRANSLATE_1_OP(INT);  // SINK / x86_32_instr_interrupts.cc
X86_32_TRANSLATE_0_OP(INTO); // x86_32_instr_interrupts.cc
X86_32_TRANSLATE_0_OP(INT3); // SINK / x86_32_instr_interrupts.cc

X86_32_TRANSLATE_0_OP(INVD);    // NOP / x86_32_instr_misc.cc
X86_32_TRANSLATE_1_OP(INVLPG);  // NOP / x86_32_instr_misc.cc

// X86_32_TRANSLATE_0_OP(IRET);  // Ignored until handle of interrupts
// X86_32_TRANSLATE_0_OP(IRETD); // Ignored until handle of interrupts
// X86_32_TRANSLATE_0_OP(IRETQ); // Ignored until handle of interrupts

#define X86_32_CC(id, form) X86_32_TRANSLATE_2_OP(J ## id);
#include "x86_32_cc.def"
#undef  X86_32_CC

X86_32_TRANSLATE_1_OP(JC);    // x86_32_instr_jump.cc
X86_32_TRANSLATE_1_OP(JCXZ);  // x86_32_instr_jump.cc
X86_32_TRANSLATE_1_OP(JECXZ); // x86_32_instr_jump.cc
X86_32_TRANSLATE_1_OP(JMP);   // x86_32_instr_jump.cc
X86_32_TRANSLATE_1_OP(JMPW);  // x86_32_instr_jump.cc

X86_32_TRANSLATE_0_OP(LAHF);  // x86_32_instr_load_store.cc

// X86_32_TRANSLATE_2_OP(LAR);  
// X86_32_TRANSLATE_2_OP(LDS);  
// X86_32_TRANSLATE_2_OP(LES);
// X86_32_TRANSLATE_2_OP(LFS);
// X86_32_TRANSLATE_2_OP(LGS);
// X86_32_TRANSLATE_2_OP(LSS);

X86_32_TRANSLATE_2_OP(LEA);    // x86_32_instr_load_store.cc

X86_32_TRANSLATE_0_OP(LEAVE); // x86_32_instr_stack.cc
X86_32_TRANSLATE_0_OP(LEAVEW); // x86_32_instr_stack.cc
X86_32_TRANSLATE_0_OP(LEAVEL); // x86_32_instr_stack.cc

// X86_32_TRANSLATE_0_OP(LFENCE);

X86_32_TRANSLATE_1_OP(LGDT); // NOP / x86_32_instr_load_store.cc
X86_32_TRANSLATE_1_OP(LIDT); // NOP / x86_32_instr_load_store.cc
X86_32_TRANSLATE_1_OP(LLDT); // NOP / x86_32_instr_load_store.cc
X86_32_TRANSLATE_1_OP(LMSW); // NOP / x86_32_instr_load_store.cc

X86_32_TRANSLATE_PREFIX(LOCK); // NOP / x86_32_instr_prefixes.cc

X86_32_TRANSLATE_2_OP(LODS);  // x86_32_instr_strings.cc

X86_32_TRANSLATE_1_OP(LOOP);    // x86_32_instr_loops.cc
X86_32_TRANSLATE_1_OP(LOOPE);   // x86_32_instr_loops.cc
X86_32_TRANSLATE_1_OP(LOOPNE);  // x86_32_instr_loops.cc
X86_32_TRANSLATE_1_OP(LOOPW);   // x86_32_instr_loops.cc
X86_32_TRANSLATE_1_OP(LOOPEW);  // x86_32_instr_loops.cc
X86_32_TRANSLATE_1_OP(LOOPNEW); // x86_32_instr_loops.cc

// X86_32_TRANSLATE_2_OP(LSL);

// X86_32_TRANSLATE_1_OP(LTR); // should not be used in application programs.

// X86_32_TRANSLATE_0_OP(MFENCE);

// X86_32_TRANSLATE_0_OP(MONITOR);

X86_32_TRANSLATE_2_OP(MOV);  // x86_32_instr_mov.cc
X86_32_TRANSLATE_2_OP(MOVB); // x86_32_instr_mov.cc
X86_32_TRANSLATE_2_OP(MOVW); // x86_32_instr_mov.cc
X86_32_TRANSLATE_2_OP(MOVL); // x86_32_instr_mov.cc
X86_32_TRANSLATE_2_OP(MOVBE); // x86_32_instr_mov.cc

X86_32_TRANSLATE_0_OP(MOVSB); // x86_32_instr_strings.cc
X86_32_TRANSLATE_2_OP(MOVSB); // x86_32_instr_strings.cc
X86_32_TRANSLATE_0_OP(MOVSW); // x86_32_instr_strings.cc
X86_32_TRANSLATE_2_OP(MOVSW); // x86_32_instr_strings.cc
X86_32_TRANSLATE_0_OP(MOVSL); // x86_32_instr_strings.cc
X86_32_TRANSLATE_2_OP(MOVSL); // x86_32_instr_strings.cc

X86_32_TRANSLATE_2_OP(MOVSBW); // x86_32_instr_mov.cc
X86_32_TRANSLATE_2_OP(MOVSBL); // x86_32_instr_mov.cc
X86_32_TRANSLATE_2_OP(MOVSWL); // x86_32_instr_mov.cc

X86_32_TRANSLATE_2_OP(MOVZBW); // x86_32_instr_mov.cc
X86_32_TRANSLATE_2_OP(MOVZBL); // x86_32_instr_mov.cc
X86_32_TRANSLATE_2_OP(MOVZWL); // x86_32_instr_mov.cc

X86_32_TRANSLATE_1_OP(MUL);  // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(MULB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(MULW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(MULL); // x86_32_instr_arithmetics.cc

X86_32_TRANSLATE_0_OP(MWAIT); // NOP / x86_32_instr_misc.cc

X86_32_TRANSLATE_1_OP(NEG);  // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(NEGB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(NEGW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_1_OP(NEGL); // x86_32_instr_arithmetics.cc

X86_32_TRANSLATE_0_OP(NOP);  // NOP / x86_32_instr_misc.cc
X86_32_TRANSLATE_1_OP(NOP);  // NOP / x86_32_instr_misc.cc
X86_32_TRANSLATE_1_OP(NOPW); // NOP / x86_32_instr_misc.cc
X86_32_TRANSLATE_1_OP(NOPL); // NOP / x86_32_instr_misc.cc

X86_32_TRANSLATE_1_OP(NOT);  // x86_32_instr_booleans.cc
X86_32_TRANSLATE_1_OP(NOTB); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_1_OP(NOTW); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_1_OP(NOTL); // x86_32_instr_booleans.cc

X86_32_TRANSLATE_2_OP(OR);  // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(ORB); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(ORW); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(ORL); // x86_32_instr_booleans.cc

// X86_32_TRANSLATE_0_OP(OUT);
// X86_32_TRANSLATE_1_OP(OUT);
// X86_32_TRANSLATE_0_OP(OUTSB);
// X86_32_TRANSLATE_2_OP(OUTSB);
// X86_32_TRANSLATE_0_OP(OUTSW);
// X86_32_TRANSLATE_2_OP(OUTSW);
// X86_32_TRANSLATE_0_OP(OUTSL);
// X86_32_TRANSLATE_2_OP(OUTSL);
// X86_32_TRANSLATE_0_OP(OUTSD);
// X86_32_TRANSLATE_2_OP(OUTSD);

X86_32_TRANSLATE_0_OP(PAUSE); // NOP / x86_32_instr_misc.cc

X86_32_TRANSLATE_1_OP(POP); // x86_32_instr_stack.cc
X86_32_TRANSLATE_1_OP(POPW); // x86_32_instr_stack.cc
X86_32_TRANSLATE_1_OP(POPL); // x86_32_instr_stack.cc
X86_32_TRANSLATE_0_OP(POPA);  // x86_32_instr_stack.cc
X86_32_TRANSLATE_0_OP(POPAW);  // x86_32_instr_stack.cc
X86_32_TRANSLATE_0_OP(POPAL);  // x86_32_instr_stack.cc

X86_32_TRANSLATE_2_OP(POPCNT); // x86_32_instr_misc.cc

X86_32_TRANSLATE_0_OP(POPF); // x86_32_instr_stack.cc
X86_32_TRANSLATE_0_OP(POPFW); // x86_32_instr_stack.cc

X86_32_TRANSLATE_1_OP(PREFETCHT0); // NOP / x86_32_instr_misc.cc
X86_32_TRANSLATE_1_OP(PREFETCHT1); // NOP / x86_32_instr_misc.cc
X86_32_TRANSLATE_1_OP(PREFETCHT2); // NOP / x86_32_instr_misc.cc
X86_32_TRANSLATE_1_OP(PREFETCHNTA); // NOP / x86_32_instr_misc.cc


X86_32_TRANSLATE_1_OP(PUSH);  // x86_32_instr_stack.cc
X86_32_TRANSLATE_1_OP(PUSHW); // x86_32_instr_stack.cc
X86_32_TRANSLATE_1_OP(PUSHL); // x86_32_instr_stack.cc

X86_32_TRANSLATE_0_OP(PUSHA);  // x86_32_instr_stack.cc
X86_32_TRANSLATE_0_OP(PUSHAW); // x86_32_instr_stack.cc
X86_32_TRANSLATE_0_OP(PUSHAL); // x86_32_instr_stack.cc

X86_32_TRANSLATE_0_OP(PUSHF);  // x86_32_instr_stack.cc
X86_32_TRANSLATE_0_OP(PUSHFW); // x86_32_instr_stack.cc

X86_32_TRANSLATE_1_OP(RCL);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RCL);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(RCLB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RCLB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(RCLW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RCLW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(RCLL); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RCLL); // x86_32_instr_shift.cc

X86_32_TRANSLATE_1_OP(RCR);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RCR);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(RCRB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RCRB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(RCRW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RCRW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(RCRL); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RCRL); // x86_32_instr_shift.cc

X86_32_TRANSLATE_1_OP(ROL);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(ROL);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(ROLB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(ROLB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(ROLW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(ROLW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(ROLL); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(ROLL); // x86_32_instr_shift.cc

X86_32_TRANSLATE_1_OP(ROR);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(ROR);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(RORB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RORB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(RORW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RORW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(RORL); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(RORL); // x86_32_instr_shift.cc

// X86_32_TRANSLATE_0_OP(RDMSR);

// X86_32_TRANSLATE_0_OP(RDPMC);

// X86_32_TRANSLATE_1_OP(RDRAND);

// X86_32_TRANSLATE_0_OP(RDTSC); 

// X86_32_TRANSLATE_0_OP(RDTSCP);

X86_32_TRANSLATE_PREFIX(REP); // x86_32_instr_prefixes.cc
X86_32_TRANSLATE_PREFIX(REPE); // x86_32_instr_prefixes.cc
X86_32_TRANSLATE_PREFIX(REPZ); // x86_32_instr_prefixes.cc
X86_32_TRANSLATE_PREFIX(REPNE); // x86_32_instr_prefixes.cc
X86_32_TRANSLATE_PREFIX(REPNZ); // x86_32_instr_prefixes.cc

X86_32_TRANSLATE_0_OP(RET);

// X86_32_TRANSLATE_1_OP(RET);

// X86_32_TRANSLATE_0_OP(RSM);

X86_32_TRANSLATE_0_OP(SAHF); // x86_32_instr_load_store.cc

X86_32_TRANSLATE_1_OP(SAL);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SAL);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SALB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SALB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SALW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SALW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SALL); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SALL); // x86_32_instr_shift.cc

X86_32_TRANSLATE_1_OP(SAR);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SAR);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SARB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SARB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SARW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SARW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SARL); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SARL); // x86_32_instr_shift.cc

X86_32_TRANSLATE_1_OP(SHL);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SHL);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SHLB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SHLB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SHLW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SHLW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SHLL); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SHLL); // x86_32_instr_shift.cc

X86_32_TRANSLATE_1_OP(SHR);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SHR);  // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SHRB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SHRB); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SHRW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SHRW); // x86_32_instr_shift.cc
X86_32_TRANSLATE_1_OP(SHRL); // x86_32_instr_shift.cc
X86_32_TRANSLATE_2_OP(SHRL); // x86_32_instr_shift.cc

X86_32_TRANSLATE_2_OP(SBB);  // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(SBBB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(SBBW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(SBBL); // x86_32_instr_arithmetics.cc

X86_32_TRANSLATE_2_OP(SCAS); // x86_32_instr_strings.cc

#define X86_32_CC(id, form) \
  X86_32_TRANSLATE_1_OP(SET ## id); // x86_32_instr_misc.cc
#include "x86_32_cc.def" 
#undef  X86_32_CC

X86_32_TRANSLATE_1_OP(SETC);  // x86_32_instr_misc.cc
X86_32_TRANSLATE_1_OP(SETNC);  // x86_32_instr_misc.cc


// X86_32_TRANSLATE_0_OP(SFENCE);

// X86_32_TRANSLATE_1_OP(SGDT);

// X86_32_TRANSLATE_3_OP(SHLD);

// X86_32_TRANSLATE_3_OP(SHRD);

// X86_32_TRANSLATE_1_OP(SIDT);

// X86_32_TRANSLATE_1_OP(SLDT);

// X86_32_TRANSLATE_1_OP(SMSW);

X86_32_TRANSLATE_0_OP(STC); // x86_32_instr_load_store.cc

X86_32_TRANSLATE_0_OP(STD); // x86_32_instr_load_store.cc

// X86_32_TRANSLATE_0_OP(STI); 

X86_32_TRANSLATE_2_OP(STOS); // x86_32_instr_strings.cc

// X86_32_TRANSLATE_1_OP(STR);

X86_32_TRANSLATE_2_OP(SUB);  // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(SUBB); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(SUBW); // x86_32_instr_arithmetics.cc
X86_32_TRANSLATE_2_OP(SUBL); // x86_32_instr_arithmetics.cc

// X86_32_TRANSLATE_0_OP(SWAPGS);

// X86_32_TRANSLATE_0_OP(SYSCALL);

// X86_32_TRANSLATE_0_OP(SYSENTER);

// X86_32_TRANSLATE_0_OP(SYSEXIT);

// X86_32_TRANSLATE_0_OP(SYSRET);

X86_32_TRANSLATE_2_OP(TEST);  // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(TESTB); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(TESTW); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(TESTL); // x86_32_instr_booleans.cc

// X86_32_TRANSLATE_0_OP(UD2);

// X86_32_TRANSLATE_0_OP(VERR);

// X86_32_TRANSLATE_1_OP(VERR);

// X86_32_TRANSLATE_0_OP(VERW);

// X86_32_TRANSLATE_1_OP(VERW);

// X86_32_TRANSLATE_0_OP(WBINVD);

// X86_32_TRANSLATE_0_OP(WRMSR);

X86_32_TRANSLATE_2_OP(XADD); // x86_32_instr_arithmetics.cc

X86_32_TRANSLATE_2_OP(XCHG); // x86_32_instr_misc.cc

// X86_32_TRANSLATE_0_OP(XGETBV);

// X86_32_TRANSLATE_1_OP(XLAT);

// X86_32_TRANSLATE_0_OP(XLATB);

X86_32_TRANSLATE_2_OP(XOR);  // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(XORB); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(XORW); // x86_32_instr_booleans.cc
X86_32_TRANSLATE_2_OP(XORL); // x86_32_instr_booleans.cc

// X86_32_TRANSLATE_1_OP(XRSTOR);

// X86_32_TRANSLATE_1_OP(XSAVE);

// X86_32_TRANSLATE_1_OP(XSAVEOPT);

// X86_32_TRANSLATE_0_OP(XSETBV);

/******************************************************************************
 *
 * NOT (YET ?) SUPPORTED OPERATIONS
 *
 ******************************************************************************/

// X86_32_TRANSLATE_2_OP(AESDEC);
// X86_32_TRANSLATE_3_OP(AESDEC);
// X86_32_TRANSLATE_2_OP(AESDECLAST);
// X86_32_TRANSLATE_3_OP(AESDECLAST);
// X86_32_TRANSLATE_2_OP(AESENC);
// X86_32_TRANSLATE_3_OP(AESENC);
// X86_32_TRANSLATE_2_OP(AESENCLAST);
// X86_32_TRANSLATE_3_OP(AESENCLAST);
// X86_32_TRANSLATE_2_OP(AESIMC);
// X86_32_TRANSLATE_3_OP(AESKEYGENASSIST);
// X86_32_TRANSLATE_2_OP(ADDPD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(ADDPD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(ADDPS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(ADDPS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(ADDSD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(ADDSD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(ADDSS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(ADDSS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(ADDSUBPD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(ADDSUBPD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(ADDSUBPS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(ADDSUBPS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(ANDPD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(ANDPD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(ANDPS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(ANDPS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(ANDNPD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(ANDNPD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(ANDNPS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(ANDNPS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(ARPL);
// X86_32_TRANSLATE_3_OP(BLENDPD); /* FP instruction */
// X86_32_TRANSLATE_4_OP(BLENDPD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(BLENDPS); /* FP instruction */
// X86_32_TRANSLATE_4_OP(BLENDPS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(BLENDVPD); /* FP instruction */
// X86_32_TRANSLATE_4_OP(BLENDVPD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(BLENDVPS); /* FP instruction */
// X86_32_TRANSLATE_4_OP(BLENDVPS); /* FP instruction */
// X86_32_TRANSLATE_0_OP(CDQE);  // 64-bit insctruction

// X86_32_TRANSLATE_0_OP(CMPSQ);  // 64bits mode
// X86_32_TRANSLATE_2_OP(CMPSQ);  // 64 bits mode
// X86_32_TRANSLATE_3_OP(CMPPD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(CMPPS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(CMPSS); /* FP instruction */
// X86_32_TRANSLATE_1_OP(CMPXCHG8B);  // 64 bits mode
// X86_32_TRANSLATE_1_OP(CMPXCHG16B); // 64 bits mode

// X86_32_TRANSLATE_2_OP(COMISD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(COMISS); /* FP instruction */
// X86_32_TRANSLATE_0_OP(CQO); // 64 bits mode

// X86_32_TRANSLATE_2_OP(CVTDQ2PD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTDQ2PS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTPD2DQ); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTPD2PI); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTPD2PS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTPI2PD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTPI2PS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTPS2DQ); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTPS2PD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTPS2PI); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTSD2SI); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTSD2SS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(CVTSD2SS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTSI2SD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(CVTSI2SD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTSI2SS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(CVTSI2SS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTSS2SD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(CVTSS2SD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTSS2SI); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTTPD2DQ); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTTPD2PI); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTTPS2DQ); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTTPS2PI); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTTSD2SI); /* FP instruction */
// X86_32_TRANSLATE_2_OP(CVTTSS2SI); /* FP instruction */
// X86_32_TRANSLATE_2_OP(DIVPD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(DIVPD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(DIVPS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(DIVPS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(DIVSD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(DIVSD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(DIVSS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(DIVSS); /* FP instruction */
// X86_32_TRANSLATE_3_OP(DPPD); /* FP instruction */
// X86_32_TRANSLATE_3_OP(DPPS); /* FP instruction */
// X86_32_TRANSLATE_1_OP(EMMS);
// X86_32_TRANSLATE_2_OP(EXTRACTPS); /* FP instruction */
// X86_32_TRANSLATE_0_OP(F2XM1); /* FP instruction */
// X86_32_TRANSLATE_0_OP(FABS);  /* FP instruction */
// X86_32_TRANSLATE_1_OP(FADD); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FADD); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FADDB); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FADDB); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FADDW); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FADDW); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FADDL); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FADDL); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FADDS); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FADDS); /* FP instruction */
// X86_32_TRANSLATE_0_OP(FADDP); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FADDP); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FIADD); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FBLD); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FBSTP); /* FP instruction */
// X86_32_TRANSLATE_0_OP(FCHS); /* FP instruction */
// X86_32_TRANSLATE_0_OP(FCLEX); /* FP instruction */
// X86_32_TRANSLATE_0_OP(FNCLEX); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FCMOVB); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FCMOVE); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FCMOVBE); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FCMOVU); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FCMOVNB); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FCMOVNE); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FCMOVNBE); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FCMOVNU); /* FP instruction */
// X86_32_TRANSLATE_0_OP(FCOM);
// X86_32_TRANSLATE_1_OP(FCOM);
// X86_32_TRANSLATE_0_OP(FCOMP);
// X86_32_TRANSLATE_1_OP(FCOMP);
// X86_32_TRANSLATE_0_OP(FCOMPP);
// X86_32_TRANSLATE_1_OP(FCOMI); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FCOMIP); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FUCOMI); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FUCOMI); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FUCOMIP); /* FP instruction */
// X86_32_TRANSLATE_2_OP(FUCOMIP); /* FP instruction */
// X86_32_TRANSLATE_0_OP(FCOS); /* FP instruction */
// X86_32_TRANSLATE_0_OP(FDECSTP); /* FP instruction */
// X86_32_TRANSLATE_1_OP(FDIV);
// X86_32_TRANSLATE_2_OP(FDIV);
// X86_32_TRANSLATE_1_OP(FDIVB);
// X86_32_TRANSLATE_2_OP(FDIVB);
// X86_32_TRANSLATE_1_OP(FDIVW);
// X86_32_TRANSLATE_2_OP(FDIVW);
// X86_32_TRANSLATE_1_OP(FDIVL);
// X86_32_TRANSLATE_2_OP(FDIVL);
// X86_32_TRANSLATE_1_OP(FDIVS);
// X86_32_TRANSLATE_2_OP(FDIVS);
// X86_32_TRANSLATE_0_OP(FDIVP);
// X86_32_TRANSLATE_1_OP(FDIVP);
// X86_32_TRANSLATE_2_OP(FDIVP);
// X86_32_TRANSLATE_1_OP(FIDIV);
// X86_32_TRANSLATE_1_OP(FDIVR);
// X86_32_TRANSLATE_2_OP(FDIVR);
// X86_32_TRANSLATE_1_OP(FDIVRL);
// X86_32_TRANSLATE_2_OP(FDIVRL);
// X86_32_TRANSLATE_1_OP(FDIVRS);
// X86_32_TRANSLATE_2_OP(FDIVRS);
// X86_32_TRANSLATE_0_OP(FDIVRP);
// X86_32_TRANSLATE_1_OP(FDIVRP);
// X86_32_TRANSLATE_2_OP(FDIVRP);
// X86_32_TRANSLATE_1_OP(FIDIVR);
// X86_32_TRANSLATE_1_OP(FFREE);
// X86_32_TRANSLATE_1_OP(FICOM);
// X86_32_TRANSLATE_1_OP(FICOMP);
// X86_32_TRANSLATE_1_OP(FILD);
// X86_32_TRANSLATE_1_OP(FILDl);
// X86_32_TRANSLATE_1_OP(FILDLL);
// X86_32_TRANSLATE_0_OP(FINCSTP);
// X86_32_TRANSLATE_0_OP(FINIT);
// X86_32_TRANSLATE_0_OP(FNINIT);
// X86_32_TRANSLATE_1_OP(FIST);
// X86_32_TRANSLATE_1_OP(FISTL);
// X86_32_TRANSLATE_1_OP(FISTP);
// X86_32_TRANSLATE_1_OP(FISTPL);
// X86_32_TRANSLATE_1_OP(FISTPLL);
// X86_32_TRANSLATE_1_OP(FISTTP);
// X86_32_TRANSLATE_1_OP(FLD);
// X86_32_TRANSLATE_1_OP(FLDL);
// X86_32_TRANSLATE_1_OP(FLDT);
// X86_32_TRANSLATE_1_OP(FLDS);
// X86_32_TRANSLATE_0_OP(FLD1);
// X86_32_TRANSLATE_0_OP(FLDL2T);
// X86_32_TRANSLATE_0_OP(FLDL2E);
// X86_32_TRANSLATE_0_OP(FLDPI);
// X86_32_TRANSLATE_0_OP(FLDLG2);
// X86_32_TRANSLATE_0_OP(FLDLN2);
// X86_32_TRANSLATE_0_OP(FLDZ);
// X86_32_TRANSLATE_1_OP(FLDCW);
// X86_32_TRANSLATE_1_OP(FLDENV);
// X86_32_TRANSLATE_1_OP(FMUL);
// X86_32_TRANSLATE_2_OP(FMUL);
// X86_32_TRANSLATE_1_OP(FMULL);
// X86_32_TRANSLATE_2_OP(FMULL);
// X86_32_TRANSLATE_1_OP(FMULS);
// X86_32_TRANSLATE_2_OP(FMULS);
// X86_32_TRANSLATE_0_OP(FMULP);
// X86_32_TRANSLATE_1_OP(FMULP);
// X86_32_TRANSLATE_2_OP(FMULP);
// X86_32_TRANSLATE_1_OP(FIMUL);
// X86_32_TRANSLATE_0_OP(FNOP);
// X86_32_TRANSLATE_0_OP(FPATAN);
// X86_32_TRANSLATE_0_OP(FPREM);
// X86_32_TRANSLATE_0_OP(FPREM1);
// X86_32_TRANSLATE_0_OP(FPTAN);
// X86_32_TRANSLATE_0_OP(FRNDINT);
// X86_32_TRANSLATE_1_OP(FRSTOR);
// X86_32_TRANSLATE_1_OP(FSAVE);
// X86_32_TRANSLATE_1_OP(FNSAVE);
// X86_32_TRANSLATE_0_OP(FSCALE);
// X86_32_TRANSLATE_0_OP(FSIN);
// X86_32_TRANSLATE_0_OP(FSINCOS);
// X86_32_TRANSLATE_0_OP(FSQRT);
// X86_32_TRANSLATE_1_OP(FST);
// X86_32_TRANSLATE_1_OP(FSTS);
// X86_32_TRANSLATE_1_OP(FSTB);
// X86_32_TRANSLATE_1_OP(FSTW);
// X86_32_TRANSLATE_1_OP(FSTL);
// X86_32_TRANSLATE_1_OP(FSTP);
// X86_32_TRANSLATE_1_OP(FSTPS);
// X86_32_TRANSLATE_1_OP(FSTPT);
// X86_32_TRANSLATE_1_OP(FSTPL);
// X86_32_TRANSLATE_1_OP(FSTCW);
// X86_32_TRANSLATE_1_OP(FNSTCW);
// X86_32_TRANSLATE_1_OP(FSTENV);
// X86_32_TRANSLATE_1_OP(FNSTENV);
// X86_32_TRANSLATE_1_OP(FSTSW);
// X86_32_TRANSLATE_1_OP(FNSTSW);
// X86_32_TRANSLATE_1_OP(FSUB);
// X86_32_TRANSLATE_2_OP(FSUB);
// X86_32_TRANSLATE_1_OP(FSUBB);
// X86_32_TRANSLATE_2_OP(FSUBB);
// X86_32_TRANSLATE_1_OP(FSUBW);
// X86_32_TRANSLATE_2_OP(FSUBW);
// X86_32_TRANSLATE_1_OP(FSUBL);
// X86_32_TRANSLATE_2_OP(FSUBL);
// X86_32_TRANSLATE_1_OP(FSUBS);
// X86_32_TRANSLATE_2_OP(FSUBS);
// X86_32_TRANSLATE_0_OP(FSUBP);
// X86_32_TRANSLATE_1_OP(FSUBP);
// X86_32_TRANSLATE_2_OP(FSUBP);
// X86_32_TRANSLATE_1_OP(FISUB);
// X86_32_TRANSLATE_1_OP(FSUBR);
// X86_32_TRANSLATE_2_OP(FSUBR);
// X86_32_TRANSLATE_0_OP(FSUBRP);
// X86_32_TRANSLATE_1_OP(FSUBRP);
// X86_32_TRANSLATE_2_OP(FSUBRP);
// X86_32_TRANSLATE_1_OP(FISUBR);
// X86_32_TRANSLATE_1_OP(FTST);
// X86_32_TRANSLATE_0_OP(FUCOM);
// X86_32_TRANSLATE_1_OP(FUCOM);
// X86_32_TRANSLATE_0_OP(FUCOMP);
// X86_32_TRANSLATE_1_OP(FUCOMP);
// X86_32_TRANSLATE_1_OP(FUCOMPP);
// X86_32_TRANSLATE_0_OP(FXAM);
// X86_32_TRANSLATE_0_OP(FXCH);
// X86_32_TRANSLATE_1_OP(FXCH);
// X86_32_TRANSLATE_1_OP(FXRSTOR);
// X86_32_TRANSLATE_1_OP(FXSAVE);
// X86_32_TRANSLATE_0_OP(FXTRACT);
// X86_32_TRANSLATE_0_OP(FYL2X);
// X86_32_TRANSLATE_1_OP(FYL2XP1);
// X86_32_TRANSLATE_2_OP(HADDPD);
// X86_32_TRANSLATE_3_OP(HADDPD);
// X86_32_TRANSLATE_2_OP(HADDPS);
// X86_32_TRANSLATE_3_OP(HADDPS);
// X86_32_TRANSLATE_2_OP(HSUBPD);
// X86_32_TRANSLATE_3_OP(HSUBPD);
// X86_32_TRANSLATE_2_OP(HSUBPS);
// X86_32_TRANSLATE_3_OP(HSUBPS);
// X86_32_TRANSLATE_3_OP(INSERTPS);
// X86_32_TRANSLATE_1_OP(JRCXZ);
// X86_32_TRANSLATE_2_OP(LDDQU);
// X86_32_TRANSLATE_1_OP(LDMXCSR);
// X86_32_TRANSLATE_0_OP(LODSQ); //64 bits mode
// X86_32_TRANSLATE_2_OP(MASKMOVDQU);
// X86_32_TRANSLATE_3_OP(VMASKMOV);
// X86_32_TRANSLATE_2_OP(MASKMOVQ);
// X86_32_TRANSLATE_2_OP(MAXPD);
// X86_32_TRANSLATE_3_OP(MAXPD);
// X86_32_TRANSLATE_2_OP(MAXPS);
// X86_32_TRANSLATE_3_OP(MAXPS);
// X86_32_TRANSLATE_2_OP(MAXSD);
// X86_32_TRANSLATE_3_OP(MAXSD);
// X86_32_TRANSLATE_2_OP(MAXSS);
// X86_32_TRANSLATE_3_OP(MAXSS);
// X86_32_TRANSLATE_2_OP(MINPD);
// X86_32_TRANSLATE_3_OP(MINPD);
// X86_32_TRANSLATE_2_OP(MINPS);
// X86_32_TRANSLATE_3_OP(MINPS);
// X86_32_TRANSLATE_2_OP(MINSD);
// X86_32_TRANSLATE_3_OP(MINSD);
// X86_32_TRANSLATE_2_OP(MINSS);
// X86_32_TRANSLATE_3_OP(MINSS);
// X86_32_TRANSLATE_2_OP(MOVAPD);
// X86_32_TRANSLATE_2_OP(MOVAPS);
// X86_32_TRANSLATE_2_OP(MOVDDUP);
// X86_32_TRANSLATE_2_OP(MOVDQA);
// X86_32_TRANSLATE_2_OP(MOVDQU);
// X86_32_TRANSLATE_2_OP(MOVDQ2Q);
// X86_32_TRANSLATE_2_OP(MOVD);
// X86_32_TRANSLATE_2_OP(MOVQ);
// X86_32_TRANSLATE_2_OP(MOVHLPS);
// X86_32_TRANSLATE_3_OP(MOVHLPS);
// X86_32_TRANSLATE_2_OP(MOVHPD);
// X86_32_TRANSLATE_3_OP(MOVHPD);
// X86_32_TRANSLATE_2_OP(MOVHPS);
// X86_32_TRANSLATE_3_OP(MOVHPS);
// X86_32_TRANSLATE_2_OP(MOVLHPS);
// X86_32_TRANSLATE_3_OP(MOVLHPS);
// X86_32_TRANSLATE_2_OP(MOVLPD);
// X86_32_TRANSLATE_3_OP(MOVLPD);
// X86_32_TRANSLATE_2_OP(MOVLPS);
// X86_32_TRANSLATE_3_OP(MOVLPS);
// X86_32_TRANSLATE_2_OP(MOVMSKPD);
// X86_32_TRANSLATE_2_OP(MOVMSKPS);
// X86_32_TRANSLATE_2_OP(MOVNTDQA);
// X86_32_TRANSLATE_2_OP(MOVNTDQ);
// X86_32_TRANSLATE_2_OP(MOVNTI);
// X86_32_TRANSLATE_2_OP(MOVNTPD);
// X86_32_TRANSLATE_2_OP(MOVNTPS);
// X86_32_TRANSLATE_2_OP(MOVNTQ);
// X86_32_TRANSLATE_2_OP(MOVQ2DQ);
// X86_32_TRANSLATE_2_OP(MOVSQ);
// X86_32_TRANSLATE_2_OP(MOVSHDUP);
// X86_32_TRANSLATE_2_OP(MOVSLDUP);
// X86_32_TRANSLATE_2_OP(MOVSS);
// X86_32_TRANSLATE_3_OP(MOVSS);
// X86_32_TRANSLATE_2_OP(MOVSXD);
// X86_32_TRANSLATE_2_OP(MOVUPD);
// X86_32_TRANSLATE_2_OP(MOVUPS);
// X86_32_TRANSLATE_3_OP(MPSADBW);
// X86_32_TRANSLATE_2_OP(MULPD);
// X86_32_TRANSLATE_3_OP(MULPD);
// X86_32_TRANSLATE_2_OP(MULPS);
// X86_32_TRANSLATE_3_OP(MULPS);
// X86_32_TRANSLATE_2_OP(MULSD);
// X86_32_TRANSLATE_3_OP(MULSD);
// X86_32_TRANSLATE_2_OP(MULSS);
// X86_32_TRANSLATE_3_OP(MULSS);
// X86_32_TRANSLATE_2_OP(ORPD);
// X86_32_TRANSLATE_3_OP(ORPD);
// X86_32_TRANSLATE_2_OP(ORPS);
// X86_32_TRANSLATE_3_OP(ORPS);
// X86_32_TRANSLATE_2_OP(PABSB);
// X86_32_TRANSLATE_2_OP(PABSW);
// X86_32_TRANSLATE_2_OP(PABSD);
// X86_32_TRANSLATE_2_OP(PACKSSWB);
// X86_32_TRANSLATE_3_OP(PACKSSWB);
// X86_32_TRANSLATE_2_OP(PACKSSDW);
// X86_32_TRANSLATE_3_OP(PACKSSDW);
// X86_32_TRANSLATE_2_OP(PACKUSDW);
// X86_32_TRANSLATE_3_OP(PACKUSDW);
// X86_32_TRANSLATE_2_OP(PACKUSWB);
// X86_32_TRANSLATE_3_OP(PACKUSWB);
// X86_32_TRANSLATE_2_OP(PADDB);
// X86_32_TRANSLATE_3_OP(PADDB);
// X86_32_TRANSLATE_2_OP(PADDW);
// X86_32_TRANSLATE_3_OP(PADDW);
// X86_32_TRANSLATE_2_OP(PADDD);
// X86_32_TRANSLATE_3_OP(PADDD);
// X86_32_TRANSLATE_2_OP(PADDQ);
// X86_32_TRANSLATE_3_OP(PADDQ);
// X86_32_TRANSLATE_2_OP(PADDSB);
// X86_32_TRANSLATE_3_OP(PADDSB);
// X86_32_TRANSLATE_2_OP(PADDSW);
// X86_32_TRANSLATE_3_OP(PADDSW);
// X86_32_TRANSLATE_2_OP(PADDUSB);
// X86_32_TRANSLATE_3_OP(PADDUSB);
// X86_32_TRANSLATE_2_OP(PADDUSW);
// X86_32_TRANSLATE_3_OP(PADDUSW);
// X86_32_TRANSLATE_3_OP(PALIGNR);
// X86_32_TRANSLATE_2_OP(PAND);
// X86_32_TRANSLATE_3_OP(PAND);
// X86_32_TRANSLATE_2_OP(PANDN);
// X86_32_TRANSLATE_3_OP(PANDN);
// X86_32_TRANSLATE_2_OP(PAVGB);
// X86_32_TRANSLATE_3_OP(PAVGB);
// X86_32_TRANSLATE_2_OP(PAVGW);
// X86_32_TRANSLATE_3_OP(PAVGW);
// X86_32_TRANSLATE_3_OP(PBLENDVB);
// X86_32_TRANSLATE_3_OP(PBLENDW);
// X86_32_TRANSLATE_2_OP(PCLMULQDQ);
// X86_32_TRANSLATE_3_OP(PCLMULQDQ);
// X86_32_TRANSLATE_2_OP(PCMPEQB);
// X86_32_TRANSLATE_3_OP(PCMPEQB);
// X86_32_TRANSLATE_2_OP(PCMPEQW);
// X86_32_TRANSLATE_3_OP(PCMPEQW);
// X86_32_TRANSLATE_2_OP(PCMPEQD);
// X86_32_TRANSLATE_3_OP(PCMPEQD);
// X86_32_TRANSLATE_2_OP(PCMPEQQ);
// X86_32_TRANSLATE_3_OP(PCMPEQQ);
// X86_32_TRANSLATE_3_OP(PCMPESTRI);
// X86_32_TRANSLATE_3_OP(PCMPESTRM);
// X86_32_TRANSLATE_2_OP(PCMPGTB);
// X86_32_TRANSLATE_3_OP(PCMPGTB);
// X86_32_TRANSLATE_2_OP(PCMPGTW);
// X86_32_TRANSLATE_3_OP(PCMPGTW);
// X86_32_TRANSLATE_2_OP(PCMPGTD);
// X86_32_TRANSLATE_3_OP(PCMPGTD);
// X86_32_TRANSLATE_2_OP(PCMPGTQ);
// X86_32_TRANSLATE_3_OP(PCMPGTQ);
// X86_32_TRANSLATE_3_OP(PCMPISTRI);
// X86_32_TRANSLATE_3_OP(PCMPISTRM);
// X86_32_TRANSLATE_3_OP(PEXTRB);
// X86_32_TRANSLATE_3_OP(PEXTRD);
// X86_32_TRANSLATE_3_OP(PEXTRQ);
// X86_32_TRANSLATE_3_OP(PEXTRW);
// X86_32_TRANSLATE_2_OP(PHADDW);
// X86_32_TRANSLATE_3_OP(PHADDW);
// X86_32_TRANSLATE_2_OP(PHADDD);
// X86_32_TRANSLATE_3_OP(PHADDD);
// X86_32_TRANSLATE_2_OP(PHADDSW);
// X86_32_TRANSLATE_3_OP(PHADDSW);
// X86_32_TRANSLATE_2_OP(PHMINPOSUW);
// X86_32_TRANSLATE_2_OP(PHSUBW);
// X86_32_TRANSLATE_3_OP(PHSUBW);
// X86_32_TRANSLATE_2_OP(PHSUBD);
// X86_32_TRANSLATE_3_OP(PHSUBD);
// X86_32_TRANSLATE_2_OP(PHSUBSW);
// X86_32_TRANSLATE_3_OP(PHSUBSW);
// X86_32_TRANSLATE_3_OP(PINSRB);
// X86_32_TRANSLATE_3_OP(PINSRD);
// X86_32_TRANSLATE_3_OP(PINSRQ);
// X86_32_TRANSLATE_3_OP(PINSRW);
// X86_32_TRANSLATE_2_OP(PMADDUBSW);
// X86_32_TRANSLATE_3_OP(PMADDUBSW);
// X86_32_TRANSLATE_2_OP(PMADDWD);
// X86_32_TRANSLATE_3_OP(PMADDWD);
// X86_32_TRANSLATE_2_OP(PMAXSB);
// X86_32_TRANSLATE_3_OP(PMAXSB);
// X86_32_TRANSLATE_2_OP(PMAXSD);
// X86_32_TRANSLATE_3_OP(PMAXSD);
// X86_32_TRANSLATE_2_OP(PMAXSW);
// X86_32_TRANSLATE_3_OP(PMAXSW);
// X86_32_TRANSLATE_2_OP(PMAXUB);
// X86_32_TRANSLATE_3_OP(PMAXUB);
// X86_32_TRANSLATE_2_OP(PMAXUD);
// X86_32_TRANSLATE_3_OP(PMAXUD);
// X86_32_TRANSLATE_2_OP(PMAXUW);
// X86_32_TRANSLATE_3_OP(PMAXUW);
// X86_32_TRANSLATE_2_OP(PMINSB);
// X86_32_TRANSLATE_3_OP(PMINSB);
// X86_32_TRANSLATE_2_OP(PMINSD);
// X86_32_TRANSLATE_3_OP(PMINSD);
// X86_32_TRANSLATE_2_OP(PMINSW);
// X86_32_TRANSLATE_3_OP(PMINSW);
// X86_32_TRANSLATE_2_OP(PMINUB);
// X86_32_TRANSLATE_3_OP(PMINUB);
// X86_32_TRANSLATE_2_OP(PMINUD);
// X86_32_TRANSLATE_3_OP(PMINUD);
// X86_32_TRANSLATE_2_OP(PMINUW);
// X86_32_TRANSLATE_3_OP(PMINUW);
// X86_32_TRANSLATE_2_OP(PMOVMSKB);
// X86_32_TRANSLATE_2_OP(PMOVSX);
// X86_32_TRANSLATE_2_OP(PMOVZX);
// X86_32_TRANSLATE_2_OP(PMULDQ);
// X86_32_TRANSLATE_3_OP(PMULDQ);
// X86_32_TRANSLATE_2_OP(PMULHRSW);
// X86_32_TRANSLATE_3_OP(PMULHRSW);
// X86_32_TRANSLATE_2_OP(PMULHUW);
// X86_32_TRANSLATE_3_OP(PMULHUW);
// X86_32_TRANSLATE_2_OP(PMULHW);
// X86_32_TRANSLATE_3_OP(PMULHW);
// X86_32_TRANSLATE_2_OP(PMULLD);
// X86_32_TRANSLATE_3_OP(PMULLD);
// X86_32_TRANSLATE_2_OP(PMULLW);
// X86_32_TRANSLATE_3_OP(PMULLW);
// X86_32_TRANSLATE_2_OP(PMULUDQ);
// X86_32_TRANSLATE_3_OP(PMULUDQ);

// X86_32_TRANSLATE_0_OP(POPFQ);
// X86_32_TRANSLATE_2_OP(POR);
// X86_32_TRANSLATE_3_OP(POR);

// X86_32_TRANSLATE_2_OP(PSADBW);
// X86_32_TRANSLATE_3_OP(PSADBW);
// X86_32_TRANSLATE_2_OP(PSHUFB);
// X86_32_TRANSLATE_3_OP(PSHUFB);
// X86_32_TRANSLATE_3_OP(PSHUFD);
// X86_32_TRANSLATE_3_OP(PSHUFHW);
// X86_32_TRANSLATE_3_OP(PSHUFLW);
// X86_32_TRANSLATE_3_OP(PSHUFW);
// X86_32_TRANSLATE_2_OP(PSIGNB);
// X86_32_TRANSLATE_3_OP(PSIGNB);
// X86_32_TRANSLATE_2_OP(PSIGNW);
// X86_32_TRANSLATE_3_OP(PSIGNW);
// X86_32_TRANSLATE_2_OP(PSIGND);
// X86_32_TRANSLATE_3_OP(PSIGND);
// X86_32_TRANSLATE_2_OP(PSLLDQ);
// X86_32_TRANSLATE_2_OP(PSLLW);
// X86_32_TRANSLATE_3_OP(PSLLW);
// X86_32_TRANSLATE_2_OP(PSLLD);
// X86_32_TRANSLATE_3_OP(PSLLD);
// X86_32_TRANSLATE_2_OP(PSLLQ);
// X86_32_TRANSLATE_3_OP(PSLLQ);
// X86_32_TRANSLATE_2_OP(PSRAW);
// X86_32_TRANSLATE_3_OP(PSRAW);
// X86_32_TRANSLATE_2_OP(PSRAD);
// X86_32_TRANSLATE_3_OP(PSRAD);
// X86_32_TRANSLATE_2_OP(PSRLDQ);
// X86_32_TRANSLATE_2_OP(PSRLW);
// X86_32_TRANSLATE_3_OP(PSRLW);
// X86_32_TRANSLATE_2_OP(PSRLD);
// X86_32_TRANSLATE_3_OP(PSRLD);
// X86_32_TRANSLATE_2_OP(PSRLQ);
// X86_32_TRANSLATE_3_OP(PSRLQ);
// X86_32_TRANSLATE_2_OP(PSUBB);
// X86_32_TRANSLATE_3_OP(PSUBB);
// X86_32_TRANSLATE_2_OP(PSUBW);
// X86_32_TRANSLATE_3_OP(PSUBW);
// X86_32_TRANSLATE_2_OP(PSUBD);
// X86_32_TRANSLATE_3_OP(PSUBD);
// X86_32_TRANSLATE_2_OP(PSUBQ);
// X86_32_TRANSLATE_3_OP(PSUBQ);
// X86_32_TRANSLATE_2_OP(PSUBSB);
// X86_32_TRANSLATE_3_OP(PSUBSB);
// X86_32_TRANSLATE_2_OP(PSUBSW);
// X86_32_TRANSLATE_3_OP(PSUBSW);
// X86_32_TRANSLATE_2_OP(PSUBUSB);
// X86_32_TRANSLATE_3_OP(PSUBUSB);
// X86_32_TRANSLATE_2_OP(PSUBUSW);
// X86_32_TRANSLATE_3_OP(PSUBUSW);
// X86_32_TRANSLATE_2_OP(PTEST);

// X86_32_TRANSLATE_2_OP(PUNPCKHBW);
// X86_32_TRANSLATE_3_OP(PUNPCKHBW);
// X86_32_TRANSLATE_2_OP(PUNPCKHWD);
// X86_32_TRANSLATE_3_OP(PUNPCKHWD);
// X86_32_TRANSLATE_2_OP(PUNPCKHDQ);
// X86_32_TRANSLATE_3_OP(PUNPCKHDQ);
// X86_32_TRANSLATE_2_OP(PUNPCKHQDQ);
// X86_32_TRANSLATE_3_OP(PUNPCKHQDQ);
// X86_32_TRANSLATE_2_OP(PUNPCKLBW);
// X86_32_TRANSLATE_3_OP(PUNPCKLBW);
// X86_32_TRANSLATE_2_OP(PUNPCKLWD);
// X86_32_TRANSLATE_3_OP(PUNPCKLWD);
// X86_32_TRANSLATE_2_OP(PUNPCKLDQ);
// X86_32_TRANSLATE_3_OP(PUNPCKLDQ);
// X86_32_TRANSLATE_2_OP(PUNPCKLQDQ);
// X86_32_TRANSLATE_3_OP(PUNPCKLQDQ);
// X86_32_TRANSLATE_2_OP(PXOR);
// X86_32_TRANSLATE_3_OP(PXOR);
// X86_32_TRANSLATE_2_OP(RCPPS);
// X86_32_TRANSLATE_2_OP(RCPSS);
// X86_32_TRANSLATE_3_OP(RCPSS);

// X86_32_TRANSLATE_3_OP(ROUNDPD);
// X86_32_TRANSLATE_3_OP(ROUNDPS);
// X86_32_TRANSLATE_3_OP(ROUNDSD);
// X86_32_TRANSLATE_3_OP(ROUNDSS);

// X86_32_TRANSLATE_2_OP(RSQRTPS);
// X86_32_TRANSLATE_2_OP(RSQRTSS);
// X86_32_TRANSLATE_3_OP(RSQRTSS);


// X86_32_TRANSLATE_3_OP(SHUFPD);
// X86_32_TRANSLATE_3_OP(SHUFPS);

// X86_32_TRANSLATE_2_OP(SQRTPD);
// X86_32_TRANSLATE_2_OP(SQRTPS);
// X86_32_TRANSLATE_2_OP(SQRTSD);
// X86_32_TRANSLATE_3_OP(SQRTSD);
// X86_32_TRANSLATE_2_OP(SQRTSS);
// X86_32_TRANSLATE_3_OP(SQRTSS);

// X86_32_TRANSLATE_1_OP(STMXCSR);

// X86_32_TRANSLATE_2_OP(SUBPD);
// X86_32_TRANSLATE_3_OP(SUBPD);
// X86_32_TRANSLATE_2_OP(SUBPS);
// X86_32_TRANSLATE_3_OP(SUBPS);
// X86_32_TRANSLATE_2_OP(SUBSD);
// X86_32_TRANSLATE_3_OP(SUBSD);
// X86_32_TRANSLATE_2_OP(SUBSS);
// X86_32_TRANSLATE_3_OP(SUBSS);

// X86_32_TRANSLATE_2_OP(UCOMISD);
// X86_32_TRANSLATE_2_OP(UCOMISS);
// X86_32_TRANSLATE_2_OP(UNPCKHPD);
// X86_32_TRANSLATE_3_OP(UNPCKHPD);
// X86_32_TRANSLATE_2_OP(UNPCKHPS);
// X86_32_TRANSLATE_3_OP(UNPCKHPS);
// X86_32_TRANSLATE_2_OP(UNPCKLPD);
// X86_32_TRANSLATE_3_OP(UNPCKLPD);
// X86_32_TRANSLATE_2_OP(UNPCKLPS);
// X86_32_TRANSLATE_3_OP(UNPCKLPS);

// X86_32_TRANSLATE_2_OP(XORPD);
// X86_32_TRANSLATE_3_OP(XORPD);
// X86_32_TRANSLATE_2_OP(XORPS);
// X86_32_TRANSLATE_3_OP(XORPS);

// X86_32_TRANSLATE_2_OP(VBROADCAST);
// X86_32_TRANSLATE_2_OP(VEXTRACTF128);
// X86_32_TRANSLATE_3_OP(VINSERTF128);
// X86_32_TRANSLATE_2_OP(VPERMILPD);
// X86_32_TRANSLATE_3_OP(VPERMILPD);
// X86_32_TRANSLATE_2_OP(VPERMILPS);
// X86_32_TRANSLATE_3_OP(VPERMILPS);
// X86_32_TRANSLATE_3_OP(VPERM2F128);
// X86_32_TRANSLATE_2_OP(VTESTPD);
// X86_32_TRANSLATE_2_OP(VTESTPS);
// X86_32_TRANSLATE_0_OP(VZEROALL);
// X86_32_TRANSLATE_0_OP(VZEROUPPER);

// X86_32_TRANSLATE_0_OP(WAIT);
// X86_32_TRANSLATE_0_OP(FWAIT);

#endif /* ! X86_32_TRANSLATION_FUNCTIONS_HH */
